﻿using C1.Win.C1FlexGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace FocusRectangleStyle
{
    public partial class Form1 : Form
    {
        private CellStyle _focusRowStyle;

        public Form1()
        {
            InitializeComponent();

            _focusRowStyle = _flex.Styles.Focus.Clone();
            _focusRowStyle.Border.Color = Color.DarkGray;
            _focusRowStyle.Border.Direction = BorderDirEnum.Horizontal;
            _focusRowStyle.Border.Style = BorderStyleEnum.Double;

            _flex.DataSource = GetDataTable("Order Details");

            // Apply _focusRowStyle to inital Row
            _flex.Rows[_flex.Row].Style = _focusRowStyle;

            // You can also show record selector to indicate the active row
            _flex.ShowCursor = true;

            _flex.AfterRowColChange += _flex_AfterRowColChange; ;
            
        }

        private void _flex_AfterRowColChange(object sender, RangeEventArgs e)
        {
            for (int row = e.OldRange.TopRow; row <= e.OldRange.BottomRow; ++row)
                _flex.Rows[row].Style = _flex.Styles.Normal;
            _flex.Rows[e.NewRange.TopRow].Style = _focusRowStyle;
        }

        private DataTable GetDataTable(string tableName)
        {
            string connectionString = GetConnectionString();
            string commandText = $"select * from [{tableName}]";
            OleDbDataAdapter adapter = new OleDbDataAdapter(commandText, connectionString);
            DataTable table = new DataTable(tableName);
            adapter.Fill(table);

            return table;
        }

        private string GetConnectionString()
        {
            string path = Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\ComponentOne Samples\Common";
            string conn = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source={0}\\C1NWind.mdb";
            return String.Format(conn, path);
        }
    }
}
